# $Id: debug.py 529 2007-12-20 21:04:22Z lukasz $
from testing.core import *
from testing import tui

import subprocess
import tempfile
import sys


def gdb( argv, test, result, options, with_libtool=False ):
	argv = list(argv)
	gdb_init = tempfile.NamedTemporaryFile()
	#gdb_init.write( " ".join(["set args"]+argv) + "\n" )
	gdb_init.write( " ".join(["run"]+argv[1:]) + "\n" )
	#gdb_init.write( "quit\n" )
	gdb_init.flush()
	init_files = []
	if options.gdb_init:
		init_files.append( options.gdb_init )
	init_files.append( gdb_init.name )

	def gdb_argv():
		if with_libtool:
			yield "libtool"
			yield "--mode=execute"
		yield "gdb"
		for f in init_files:
			yield "-x"
			yield f
		yield argv[0]

	print "run: %s" % " ".join( list(gdb_argv()) )
	print "debugged program: %s" % " ".join(argv)
	try:
		subprocess.check_call( list(gdb_argv()) )
	except KeyboardInterrupt:
		raise
	except:
		result.addError( test, sys.exc_info() )

	gdb_init.close()


class gdb_test_runner( Test_runner ):
	def __init__( self, options ):
		super( gdb_test_runner, self ).__init__( Test_result_base )
		self.options = options

	def create_result( self, testsuite ):
		return tui._TUI_test_result( testsuite, self.options, sys.stdout )

	def run( self, testsuite ):
		result = self.create_result( testsuite )
		result.beforeTestsuite( testsuite )
		for test in iterate_tests(testsuite):
			if hasattr( test, "run_with_debugger" ):
				test.run_with_debugger( self.options, result )
			else:
				def testsuite_argv():
					yield sys.executable
					yield sys.argv[0]
					for opt in compose_options( self.options ):
						yield opt
					yield test_name( test )
				gdb( testsuite_argv(), test, result, self.options )
		result.afterTestsuite( testsuite )
		return result

