
cdef extern from "stddef.h":
	ctypedef int size_t
cdef extern from "stdio.h":
	ctypedef struct FILE
	void setbuf( FILE *stream, char *buf )
	void setvbuf( FILE *stream, char *buf, int mode, size_t size )
	FILE *stdin
	FILE *stdout
	FILE *stderr

cdef extern from "unistd.h":
	int fcntl( int fd, int cmd, long arg )
cdef extern from "fcntl.h":
	ctypedef enum:
		F_GETFL
		F_SETFL
		O_NONBLOCK

def unbuffered_stdout():
	setbuf( stdout, NULL )

def fd_blocking( int fd, block ):
	cdef int flags
	cdef int rc
	flags = fcntl( fd, F_GETFL, 0 )
	if flags == -1:
		raise OSError()
	if block:
		flags = flags & ~O_NONBLOCK
	else:
		flags = flags | O_NONBLOCK
	rc = fcntl( fd, F_SETFL, flags )
	if rc == -1:
		raise OSError()
	return fd


